#
# $Id: Ci.rb,v 1.179 2005/12/31 13:36:29 ys Exp $
#

puts Time.now

CiVersion = 'epsilon.0'
CiCode = 'Synthetic Life'
CiString = "C.i. - Compact Interface for 2ch. version #{CiVersion} (#{CiCode})"
CiShortString = "C.i. (version: #{CiVersion})"
CiTitleString = "C.i. for 2ch. version #{CiVersion} (#{CiCode})"

$KCODE = 'e'
Thread::abort_on_exception = true

# 

if $0 != __FILE__  # required spin up

	require 'ci/appcfg'
	CFG.init('ci', 'C.i.', CiVersion)

	require 'ci/sitecfg'
	CFG.load_user_cfg
	
	require 'ci/nls'
	require 'ci/httpext'
	require 'ci/bbsinit'
	BBSMenu.get if CFG::Net.bbsmenu_check
	BBSMenu.init
	
	require 'ci/util2ch'
	require 'ci/stdext'
	require 'ci/bbsboard'
	require 'ci/bbspost'
	require 'ci/bbsthread'
	
	require 'gtk2'
	require 'ci/gtkext'
	require 'ci/gtkmisc'
	require 'ci/gtkboards'
	require 'ci/gtkboard'
	require 'ci/gtkpost'
	require 'ci/gtkthread'
	require 'ci/gtkcfg'
	CFG.gui_init
	
	require 'ci/session'

else  # direct spin up

	load 'appcfg.rb'
	CFG.init('ci', 'C.i.', CiVersion)
	CFG.load_user_cfg
	
	load 'nls.rb'
	load 'httpext.rb'
	load 'bbsinit.rb'
	BBSMenu.get if CFG::Net.bbsmenu_check
	BBSMenu.init
	
	load 'util2ch.rb'
	load 'stdext.rb'
	load 'bbsboard.rb'
	load 'bbspost.rb'
	load 'bbsthread.rb'
	
	require 'gtk2'
	load 'gtkext.rb'
	load 'gtkmisc.rb'
	load 'gtkboards.rb'
	load 'gtkboard.rb'
	load 'gtkpost.rb'
	load 'gtkthread.rb'
	load 'gtkcfg.rb'
	CFG.gui_init
	
	load 'session.rb'

end
	
#

cls =  "#{CiString}\n\n"
cls << " Ruby: #{RUBY_VERSION} (#{RUBY_RELEASE_DATE})\n"
cls << " Gtk+: #{Gtk::VERSION[0]}.#{Gtk::VERSION[1]}.#{Gtk::VERSION[2]}\n"
cls << " Ruby/Gtk2: #{Gtk::BINDING_VERSION[0]}.#{Gtk::BINDING_VERSION[1]}#{Gtk::BINDING_VERSION[2]}\n"
cls << " PlatForm: #{RUBY_PLATFORM}\n"

CiLongString = cls

#

class Ci < Gtk::Window

	#
	# init & quit
	#

	def initialize

		gtkrc = CFG::SYS.root + 'gtkrc'
		Gtk::RC.parse(gtkrc) if File.exist?(gtkrc)

		@thread_chain = {}
		@switch = false
		@s_thr = Thread.fork { Thread.exit }  # thread for subject get.
		@t_thr = Thread.fork { Thread.exit }  # thread for thread get.

		super()
		realize
	end

	def init
		case ARGV[0]
		when '-v'
			puts CiLongString
			exit
		when '-g'
			CFG::Net.bbsmenu_check = true
		when '-d'
			Logger.init(CiString)
			Logger.write(__FILE__, __LINE__, '$DEBUG = true')
			$DEBUG = true
		end

		puts CFG::NLS.ruby_too_old if RUBY_VERSION < '1.6.4'

		profile = Session::Profile.read(CFG::SYS.root + 'profile')
		default_size = []
		if profile and profile.include?('size')
			default_size = profile['size'].split(':')
		else
			default_size = '500:450'.split(':')
		end

		if profile and profile.include?('origin')
			x = profile['origin'].split(':')
			move(x[0].to_i, x[1].to_i)
		end

		top_handle = Gtk::HandleBox.new.add top_buttons
		favorites_handle = Gtk::HandleBox.new.add favorites_buttons

		main = Gtk::VBox.new
		main.pack_start top_handle, false
		if CFG::UIF.bm_button_position
			main.pack_start favorites_handle, false
			main.pack_start main_pane
		else
			main.pack_start main_pane
			main.pack_start favorites_handle, false
		end

		add main

		set_default_size(default_size[0].to_i, default_size[1].to_i)
		set_title(CiTitleString)
		signal_connect('delete_event') { quit ; Gtk::main_quit }

		show_all

		if CFG::UIF.board_start_open
			if CFG::UIF.board_position  # left
				@main_pane.set_position(CFG::UIF.boardselect_width)
			else  # right
				@main_pane.set_position(default_size[0].to_i - CFG::UIF.boardselect_width)
			end
		end

		session_start
	end

	def session_start
		Thread.fork {
			@top.windmill.start('Session:0')
			session = Session.read("#{CFG::SYS.root}session")
			if session
				session.each {|board, type, dat, title|
					open_text_frame(board, dat, type, false)
					while true
						sleep Session::SLEEP_TIME
						break unless @top.windmill.q.include?('G:'.concat(dat))
					end
				}
			end
			@top.windmill.stop('Session:0')
		}

		@top.urlview.entry.set_text(CFG::NLS.greeting)

		set_focus(@subjects.child)	
	end

	def quit
		session = []
		@main_note.set_page(0)
		@main_note.next_page
		while @main_note.page != 0
			cur = @main_note.get_nth_page(@main_note.page)
			cur.vadj_info.write
			session << [cur.board, cur.class.to_s[0, 4].downcase, cur.dat, cur.title]
			@thread_chain.delete(cur.dat)
			@main_note.remove_page(@main_note.page)
			@main_note.next_page
		end
		Session.write("#{CFG::SYS.root}session", session)


		ox, oy = window.root_origin
		sx, sy = window.size
		profile = { \
			'board' => @main_note.get_nth_page(@main_note.page).board,
			'origin' => ox.to_s + ':' + oy.to_s,
			'size' => sx.to_s + ':' + sy.to_s
			}
		Session::Profile.write(CFG::SYS.root + 'profile', profile)
	end


	#
	# widgets
	#

	def top_buttons
		@top = GtkExt::TopButtons.new

		@top.select.signal_connect('clicked') {
			if @top.select.active?
				if CFG::UIF.board_position  # left
					@main_pane.set_position(CFG::UIF.boardselect_width)
				else  # right
					@main_pane.set_position(self.size[0] - CFG::UIF.boardselect_width)
				end
				set_focus(@board_tree.child)
			else
				if CFG::UIF.board_position  # left
					@main_pane.set_position(0)
				else  # right
					@main_pane.set_position(5000)
				end
				set_focus(@main_note.get_nth_page(@main_note.page).child)
			end
		}

		#@top.bookmark.signal_connect('clicked') {
		#	@subjects.filter.bookmark = @top.bookmark.active?
		#	@subjects.update(false)
		#}

		@top.reload.signal_connect('clicked') {
			cur = @main_note.get_nth_page(@main_note.page)
			if cur.class.to_s !~ /ThreadFrame/
				@s_thr = Thread.fork {
					w = @top.windmill.start('U:Subject')
					if w
						cur.update
						@top.windmill.stop('U:Subject')
					end
				}
			else
				@t_thr = Thread.fork {
					w = @top.windmill.start('U:'.concat(cur.dat))
					if w
						cur.update
						@top.windmill.stop('U:'.concat(cur.dat))
					end
				}
			end
			#set_focus(@main_note.get_nth_page(@main_note.page).child)
		}

		@top.cancel.signal_connect('clicked') {
			@s_thr.kill if @s_thr.alive? ; @subjects.rollback
			@t_thr.kill if @t_thr.alive? ; @top.windmill.kill
		}

		@top.find.signal_connect('clicked') {
			@switch = true  # not yet. äƤ ... ʤޤ󥹥ȤǤ뤳ȤϳΤ
				#if CFG::ETC.list.include?(@main_note.get_nth_page(main_note.page).board)  # not yet. ᤮¤
				#	@top.urlview.add_str(BBSBoard::EXTRA + CFG::ETC.list.fetch(@subjects.board), @top.urlview.entry.get_text)
				#else
					@top.urlview.add_str(@main_note.get_nth_page(@main_note.page).board, @top.urlview.entry.text)
				#end
			@switch = false
			@main_note.get_nth_page(@main_note.page).find(Uconv.u8toeuc(@top.urlview.entry.text))
			switch_note(true) if @top.urlview.entry.text == ''
		}

		@top.followup.set_sensitive(false)
		@top.followup.signal_connect('clicked') {
			if defined?(@main_note.get_nth_page(@main_note.page).post_open)
				@main_note.get_nth_page(@main_note.page).post_open
				set_focus(@main_note.get_nth_page(@main_note.page).post.text)
			end
		}

		@top.urlview.entry.signal_connect('activate') {
			u = @top.urlview.entry.text
			case u
			when CFG::Regex.uri_2ch
				b = $3 ; d = $4
				b.sub(/(.+?)\/(\d+)/) { b = $1 ; d = $2 } if b =~ /\//
				open_text_frame(b, d.concat('.dat'))
			when CFG::Regex.uri_2ch_board
				board = $1
				switch_board(board, true) if BBSMenu::Servers.include?(board)
			else
				@top.find.clicked
			end
		}

		@top.windmill.signal_connect('button_press_event') {|w, e|
			show_config.popup(nil, nil, e.button, e.time)
		}

		return(@top)
	end

	def board_select
		@board_tree = BoardSelector.new

		@board_tree.child.signal_connect('key_press_event') {|w, e|
			case e.keyval
			when Gdk::Keyval::GDK_space
				node = ''
				@board_tree.child.each_selection {|n| node = n }
				if @board_tree.child.get_node_info(node)[6]
					select_node(node)
				else
					@board_tree.child.toggle_expansion(node)
				end
			when Gdk::Keyval::GDK_r
				@s_thr = Thread.fork {
					w = @top.windmill.start('U:BoardMenu')
					if w
						set_focus(@main_note.get_nth_page(main_note.page).child.child)
						@board_tree.update
						@top.windmill.stop('U:BoardMenu')
					end
				}
			when Gdk::Keyval::GDK_S then @top.select.clicked
			when Gdk::Keyval::GDK_q then @top.select.clicked
			end
		}

		@board_tree.child.signal_connect('button_release_event') {|w, e|
			case e.button
			when 1
				node = @board_tree.child.selection.selected
				if node.has_child? == false
					select_node(node)
				end
			end
		}

		return(@board_tree)
	end

	def subject_frame
		profile = Session::Profile.read(CFG::SYS.root + 'profile')
		if profile
			@subjects = SubjectFrame.new(profile['board'], CFG::ETC.list.include?(profile['board']))
		else
			@subjects = SubjectFrame.new(false)
		end

		@subjects.child.signal_connect('button_release_event') {|w, e|
			if @subjects.pop? == false
				select_thread if e.button == 1
			end
		}

		@subjects.child.signal_connect('key_press_event') {|w, e|
			case e.keyval
			when Gdk::Keyval::GDK_space then select_thread
			when Gdk::Keyval::GDK_h then @main_note.prev_page ; switch_note(true)
			when Gdk::Keyval::GDK_l then @main_note.next_page ; switch_note(true)
			when Gdk::Keyval::GDK_r then @top.reload.clicked
			when Gdk::Keyval::GDK_c then @top.cancel.clicked
			when Gdk::Keyval::GDK_S then @top.select.clicked
			when Gdk::Keyval::GDK_p then subject_frame_type_toggle
			when Gdk::Keyval::GDK_t then subject_frame_hide_toggle
			when Gdk::Keyval::GDK_slash then focus_find
			when Gdk::Keyval::GDK_q
				quit ; Gtk::main_quit
			when Gdk::Keyval::GDK_less  # '<'
				@main_note.set_page(0) ; switch_note(true)
			when Gdk::Keyval::GDK_greater  # '>'
				@main_note.set_page(@thread_chain.size) ; switch_note(true)
			when Gdk::Keyval::GDK_f 
				@subjects.freeze
				@subjects.thaw
				@subjects.refresh
			else
			end
		}

		return(@subjects)
	end

	def favorites_buttons
		num = CFG::UIF.favorite_buttons
		num = 256 if num == 0
		box = Gtk::HBox.new
		favorites = BBSMenu.favorite
		if favorites != []
			num = favorites.size if num > favorites.size
			num.times {|i|
				n, uri = favorites[i]
				b = Gtk::Button.new(Uconv.euctou8(n))
				b.signal_connect('clicked') {
					server, board = String2ch.parse_uri(uri)
					switch_board(board, true)
				}
				b.relief = Gtk::RELIEF_NONE
				box.pack_start b

				if i + 1 < 10
					self.signal_connect('key_press_event') {|w, e|
						if e.state == Gdk::Window::ModifierType::CONTROL_MASK
							case e.keyval
							when eval("Gdk::Keyval::GDK_#{i + 1}") then b.clicked
							end
						end
					}
				end
			}
		end
		return(box)
	end

	def main_note  # not yet. 
		sf = subject_frame
		sfbx_r = Gtk::Button.new.add Pix.get('all') ; sfbx_r.signal_connect('clicked') { sf.refresh }
		sfbx_b = Gtk::Button.new.add Pix.get('bookmark2') ; sfbx_b.signal_connect('clicked') { sf.check('bookmark') }
		sfbx_u = Gtk::Button.new.add Pix.get('update') ; sfbx_u.signal_connect('clicked') { sf.check('update') }
		sfbx_c = Gtk::Button.new.add Pix.get('cache_plus') ; sfbx_c.signal_connect('clicked') { sf.check('cache_plus') }
		sfbx = Gtk::HBox.new  # FIXME!!

		if CFG::ETC.list.include?(sf.board)  # not yet. ᤮
			@slabel = Gtk::Label.new("#{CFG::ETC.list.fetch(sf.board).capitalize}@Extra")
		else
			@slabel = Gtk::Label.new(" #{sf.board.capitalize}@2ch")
		end

		[sfbx_r, sfbx_b, sfbx_u, sfbx_c].each {|w| w.relief = Gtk::RELIEF_NONE }

		sfbx.pack_start sfbx_r, false, false
		sfbx.pack_start sfbx_b, false, false
		sfbx.pack_start sfbx_u, false, false
		sfbx.pack_start sfbx_c, false, false
		sfbx.pack_start @slabel
		sfbx.show_all

		@main_note = Gtk::Notebook.new
		@main_note.set_scrollable(true)
		@main_note.append_page(sf, sfbx)

		@main_note.signal_connect('button_release_event') {|w, e|
			switch_note(true) if e.button != 4 && e.button != 5
		}

		@top.urlview.set_board(@subjects.board)  # not yet. äƤʡ <=  ? (^^;

		return(@main_note)
	end

	def main_pane
		@main_pane = Gtk::HPaned.new
		if CFG::UIF.board_position
			@main_pane.pack1(board_select, false, true)
			@main_pane.pack2(main_note, false, true)
		else
			@main_pane.pack1(main_note, false, true)
			@main_pane.pack2(board_select, false, true)
		end
		if CFG::UIF.board_position  # left
			@main_pane.set_position(0)
		else  # right
			@main_pane.set_position(5000)
		end
		return(@main_pane)
	end


	#
	# callback_functions
	#

	def subject_frame_hide_toggle
		if @subjects.filter.abone
			@subjects.filter.abone = false
		else
			@subjects.filter.abone = true
		end
		@subjects.update(false)
	end

	def subject_frame_type_toggle
		@s_thr = Thread.fork {
			w = @top.windmill.start('U:Subject')
			if w
				@subjects.toggle
				@top.windmill.stop('U:Subject')
			end
		}
	end

	def open_text_frame(board, dat, type = 'live', focus = true)
		w = @top.windmill.start('G:'.concat(dat))
		return(false) unless w 

		@t_thr = Thread.fork {
			r = @subjects.child.selection.selected
			if @thread_chain.include?(dat)
				select_thread_tab(dat)
				@main_note.get_nth_page(@main_note.page).child.update
			else
				case type
				when 'live'
					type = 'etc' if CFG::ETC.list.include?(board)
					x = init_live_text_frame(board, dat, get_url(board, dat, type))
				when 'past'
					x = init_past_text_frame(board, dat, get_url(board, dat, 'past'))
				end
				@main_note.append_page(x[0], x[1])
				@main_note.show_all
				x[0].redraw  # append Ƥ顣
				x[0].adjust

				select_thread_tab(dat) if focus  # not yet. ??
			end
			if focus
				set_focus(@main_note.get_nth_page(@main_note.page).child)
				switch_note(true)
			end
			@subjects.cached(r) if @subjects.board == board
			@top.windmill.stop('G:'.concat(dat))
		}
	end

	def init_text_frame(texts)
		texts.child.signal_connect('key_press_event') {|w, e|
			case e.keyval
			when Gdk::Keyval::GDK_h then @main_note.prev_page ; switch_note(true)
			when Gdk::Keyval::GDK_l then @main_note.next_page ; switch_note(true)
			when Gdk::Keyval::GDK_H then move_tab(texts, true)
			when Gdk::Keyval::GDK_L then move_tab(texts, false)
			when Gdk::Keyval::GDK_S then @top.select.clicked
			when Gdk::Keyval::GDK_q then close_text_frame(texts)
			when Gdk::Keyval::GDK_slash then focus_find
			when Gdk::Keyval::GDK_less  # '<'
				@main_note.set_page(0) ; switch_note(true)
			when Gdk::Keyval::GDK_greater  # '>'
				@main_note.set_page(@thread_chain.size) ; switch_note(true)
			when Gdk::Keyval::GDK_space
				if texts.vadj.value != texts.vadj.upper - texts.vadj.page_size \
					&& texts.vadj.value < texts.vadj.upper - texts.vadj.page_size
						texts.vadj.set_value(texts.vadj.value + texts.vadj.page_size / 1.1)
				elsif texts.vadj.value >= texts.vadj.upper - texts.vadj.page_size
					if CFG::UIF.thread_auto_next
						close_text_frame(texts)
						@main_note.next_page
						switch_note(true)
					end
				end
			end
		}

		texts.child.signal_connect('button_release_event') {|w, e|
			if e.button == 3 and texts.press == Gdk::Event::BUTTON_PRESS
				menu = RightMenu.new(texts.title)

				if texts.bookmark.include?(texts.dat)
					menu.bookmark.child.set_text(CFG::NLS.srm_delete_bkmk)
				else
					menu.bookmark.child.set_text(CFG::NLS.srm_add_bkmk)
				end

				if texts.abone.include?(texts.dat)
					menu.abone.child.set_text(CFG::NLS.srm_unset_abone)
				else
					menu.abone.child.set_text(CFG::NLS.srm_set_abone)
				end

				menu.title.signal_connect('activate') { menu.destroy }
				menu.bookmark.signal_connect('activate') {
					texts.bookmark.toggle
					menu.destroy
				}
				menu.abone.signal_connect('activate') {
					texts.abone.toggle
					menu.destroy
				}
			end
		 }

=begin
		texts.child.signal_connect('button_press_event') {|w, e|
			case e.button
			when 2
				do_retry = false  # not yet. 
				if texts.child.get_chars(0, 100).gsub!(/\n.*/m, '') == CFG::NLS.moved_dat_hell.gsub(/\n.*/m, '')
					do_retry = true 
				end
				if texts.child.has_selection?
					target = texts.get_selection
					if target =~ CFG::Regex.uri_2ch and do_retry
						Net2ch.exec_http_ext($2)
					elsif target =~ CFG::Regex.uri_2ch
						b = $3 ; d = $4
						b.sub(/(.+?)\/(\d+)/) { b = $1 ; d = $2 } if b =~ /\//
						open_text_frame(b, d.concat('.dat'))
					elsif target =~ CFG::Regex.uri
						Net2ch.exec_http_ext($2)
					end
				end
			end
		}
=end

		@thread_chain[texts.dat]= texts

		labels = texts.label
		case labels.size
		when 1
		when 2
			texts.close.signal_connect('clicked'){ close_text_frame(texts) }
		else
			texts.close.signal_connect('clicked'){ close_text_frame(texts) }
			texts.prev.signal_connect('clicked'){ move_tab(texts, true) }
			texts.next.signal_connect('clicked'){ move_tab(texts, false) }
		end

		return([texts, labels[0]])
	end

	def init_live_text_frame(board, dat, uri)
		texts = LiveThreadFrame.new(board, dat, uri)
		texts.child.signal_connect('key_press_event') {|w, e|
			case e.keyval
			when Gdk::Keyval::GDK_r then @top.reload.clicked
			when Gdk::Keyval::GDK_w then @top.followup.clicked
			when Gdk::Keyval::GDK_R
				@t_thr = Thread.fork {
					w = @top.windmill.start('U:'.concat(texts.dat))
					if w
						texts.reget
						set_focus(texts.child)
						@top.windmill.stop('U:'.concat(texts.dat))
					end
				}
			end
		}
		init_text_frame(texts)
	end

	def init_past_text_frame(board, dat, uri)
		texts = PastThreadFrame.new(board, dat, uri)
		init_text_frame(texts)
	end

	def close_text_frame(text_frame)
		# not yet. Download failed ˡ
		text_frame.vadj_info.write if text_frame.title !~ /Download failed/
		@thread_chain.delete(text_frame.dat)
		if @main_note.page_num(text_frame) == @main_note.page
			@main_note.remove_page(@main_note.page)
		else
			tmp = 0
			tmp = @main_note.get_nth_page(@main_note.page).dat if @main_note.page != 0
			@main_note.remove_page(@main_note.page_num(text_frame))
			@main_note.set_page(0)
			select_thread_tab(tmp) if tmp != 0
		end
		switch_note(true)
	end

	def switch_note(focus = false)
		@switch = true
		@top.followup.set_sensitive(true)
		cur = @main_note.get_nth_page(@main_note.page)
			if @main_note.page == 0
				set_title(CiTitleString)
				if CFG::ETC.list.include?(cur.board)  # not yet. ᤮
					@main_note.set_tab_label_text(cur, "#{CFG::ETC.list.fetch(cur.board).capitalize}@Extra")
				else
					@slabel.set_text(" #{cur.board.capitalize}@2ch") #FIXME!!!
				end
				@top.followup.set_sensitive(false)
				if focus
					set_focus(@subjects.child)
					if CFG::ETC.list.include?(cur.board)  # not yet. ᤮
						@top.urlview.set_board(BBSBoard::EXTRA + CFG::ETC.list.fetch(@subjects.board))
					else
						@top.urlview.set_board(@subjects.board)
					end
				end
				if CFG::ETC.list.include?(cur.board)  # not yet. ᤮
					@top.urlview.entry.set_text(cur.board)
				else
					@top.urlview.entry.set_text("http://#{BBSMenu::Servers[cur.board]}/#{cur.board}/")
				end
			elsif focus  #=> ThreadFrame and Focus
				if CFG::ETC.list.include?(cur.board)  # not yet. ᤮
					@top.urlview.set_board(BBSBoard::EXTRA + CFG::ETC.list.fetch(@subjects.board))
				else
					@top.urlview.set_board(@subjects.board)
				end
				@top.urlview.entry.set_text(cur.url)
				set_title("#{Uconv.euctou8(cur.title)} - #{CiShortString}")
				if cur.mode == 'live'
					@top.followup.set_sensitive(true)
				else
					@top.followup.set_sensitive(false)
				end
				set_focus(@main_note.get_nth_page(@main_note.page).child)
			end
		@switch = false
	end

	def switch_board(board, focus = false, etc = false)
		@s_thr.kill if @s_thr.alive?
		@subjects.rollback
		@top.windmill.stop('G:Subject')
		@top.windmill.stop('U:Subject')
		@subjects.switch(board, etc)
		@s_thr = Thread.fork {
			w = @top.windmill.start('G:Subject')
			if w
				@subjects.update(false)
				@top.windmill.stop('G:Subject')
				@main_note.set_page(0)
				switch_note(focus)
			end
		}
	end

	def select_node(node)  # from BoardMenu.
		node_info = @board_tree.get_row_data(node).uri
		if @board_tree.std?(node_info)  # 2ch standard.
			# not yet. parse_uri äƤʤ⡣Τޤ uri ľϤǤ衼ʡ
			server, board = String2ch.parse_uri(@board_tree.get_row_data(node).uri)
			switch_board(board, false)
		else  # etc.txt
			switch_board(node_info, false, true)
		end
		set_focus(@board_tree.child)
	end

	def select_thread  # from SubjectFrame.
		if CFG::UIF.tab_lock
			focus = false
		else
			focus = true
		end

		r = @subjects.child.selection.selected.get_value(0)
		if @top.windmill.q.include?('G:Subject') #=> ļĤΥ
			open_text_frame(@subjects.past, @subjects.hash[r], @subjects.past_mode, focus)
		else #=> ̾
			open_text_frame(@subjects.board, @subjects.hash[r], @subjects.mode, focus)
		end
	end

	def select_thread_tab(dat)  # from ThreadFrame.
		@main_note.set_page(0)
		@main_note.next_page
		while @main_note.get_nth_page(@main_note.page).dat != dat
			@main_note.next_page
		end
	end

	def move_tab(widget, direction)
		return if @main_note.page == 1 and direction
		return if @main_note.get_nth_page(1) == widget and direction
		if direction == true  #=> prev
			p = @main_note.page - 1
		else #=> next
			p = @main_note.page + 1
		end
		@main_note.reorder_child(widget, p)
	end

	def focus_find
		@top.urlview.entry.set_text('')
		set_focus(@top.urlview.entry)
	end

	def get_url(board = '', dat = '', mode = '')
		case mode
		when 'live'
			uri = "http://#{BBSMenu::Servers[board]}/test/read.cgi/#{board}/#{dat.sub(/\.dat/, '/')}"
		when 'past'
			uri = "file://#{CFG::SYS.root}#{board}/#{BBSBoard::PAST}/#{dat}.#{BBSBoard::CACHE}"
		when 'etc'
			uri = "#{board}#{dat}"
		end
		return(uri)
	end

	def show_config
		pop = GtkExt::ConfigPop.new
		pop.update_bbsmenu.signal_connect('activate'){
			@s_thr = Thread.fork {
				w = @top.windmill.start('U:BoardMenu')
				if w
					#FIXME!!!
					#GtkExt.parent_window(@main_note).set_focus(@main_note.get_nth_page(@main_note.page).child.child)
					@board_tree.update
					@top.windmill.stop('U:BoardMenu')
				end
			}
		}
		pop.stype.signal_connect('activate'){ subject_frame_type_toggle }
		pop.hide.signal_connect('activate'){ subject_frame_hide_toggle }
		pop.config.signal_connect('activate'){ ConfigWindow.new.show_all }
		pop.about.signal_connect('activate'){ GtkExt::About.new.show_all }
		return(pop)
	end

end


Gtk.init

ci = Ci.new
Pix = GtkExt::Pixmap.new(ci, CFG::SYS.siteroot + 'pixmap/')
ci.init

puts Time.now

Gtk.main
