#
#
# $Id: appcfg.rb,v 1.36 2005/12/29 14:34:47 ys Exp $
#
#

require "uconv"

class CFG
	CFG_SUFFIX = '.cfg'
	NG_WORDS_DAT = 'ngwords.dat'
	ETC_TXT = 'etc.txt'

	# define SYS
		sys = Struct.new('System',
			:root,
			:siteroot,
			:monazilla,
			:app_name,
			:app_name_dir,
			:app_version
			)
		SYS = sys.new()

	# define Regex
		regex = Struct.new('Regex',
			:id,
			:head_id,
			:follow,
			:follow_many,
			:quote,
			:uri,
			:uri_2ch,
			:uri_2ch_board
			)
		Regex = regex.new(
			/^(\d+:)(.*<.*?> )(: .*)/u,
			/^(\d+)/,
			eval(Uconv.euctou8('/^(.*?)([>]{1,2}\s*[\d-]+)(.*)/u')),
			eval(Uconv.euctou8('/^(.*?)([>]{1,2}\s*[\d-]+[-=,]\s?\d+)(.*)/u')),
			eval(Uconv.euctou8('/^\s[>](?![>]?\d+).*/u')),
			/^(.*?)([h|f]?t?tps?:[a-zA-Z0-9%&\?\/\;\:\@\&\=\+\$\,\-\^\_\.\!\~\*\'\\#]+)(.*)$/,
			/^(.*?)h?ttp:\/\/.+\.(2ch\.net|bbspink\.com)\/test\/read\.cgi\/(\S+)\/(\d+)(.*)$/,
			/^h?ttp:\/\/.+\.(?:2ch\.net|bbspink\.com)\/(.*)\/$/
			)

	# define UIF
		uif = Struct.new('UserInterFace',
			:board_position, 
			:board_start_open, 
			:bm_button_position,
			:tab_lock,
			:tab_width,
			:tabbutton_type,
			:favorite_buttons,
			:thread_auto_next,
			:postbox_auto_scroll,
			:postbox_height,
			:boardselect_width,
			:searched_max
		)
		UIF = uif.new(true, false, true, true, 6, 2, 0, true, true, 250, 200, 10)
		D_UIF = uif.new(true, false, true, true, 6, 2, 0, true, true, 250, 200, 10)

	# define EXT
		ext = Struct.new('ExtendModules',
			:http_cmd
		)
		EXT = ext.new('mozilla -noraise -remote "openurl(%d)"')
		D_EXT = ext.new('mozilla -noraise -remote "openurl(%d)"')

	# define Proxy
		proxy = Struct.new('ProxyServers',
			:get_addr,
			:get_port,
			:post_addr,
			:post_port
		)
		Proxy = proxy.new()
		D_Proxy = proxy.new()

	# define Color
		color = Struct.new('Colors',
			:thread_base_fg,
			:thread_quote_fg,
			:thread_header_fg,
			:thread_followup_fg,
			:thread_uri_fg,
			#
			:bookmark_bg,
			:abone_bg
		)
		Color = color.new(
			[ 0, 0, 0 ], [ 32896, 0, 32896 ], [ 0, 25700, 0 ], [ 0, 0, 65535 ], [ 0, 0, 65535 ],
			[ 55000, 55000, 55000 ], [ 63052, 46028, 48793 ]
			)
		D_Color = color.new(
			[ 0, 0, 0 ], [ 32896, 0, 32896 ], [ 0, 25700, 0 ], [ 0, 0, 65535 ], [ 0, 0, 65535 ],
			[ 55000, 55000, 55000 ], [ 63052, 46028, 48793 ]
			)

	# define GDK_Color => Gdk::Color
		GDK_Color = color.new()

	# define Identity
		identity = Struct.new('Identity',
			:myfavorites,
			:name,
			:mailto
		)
		Identity = identity.new([], '̵̾', 'sage')
		D_Identity = identity.new([], '̵̾', 'sage')

	# define Net
		net = Struct.new('Network',
			:bbsmenu_check,
			:bbsmenu_url,
			:ng_word
		)
		Net = net.new(false, 'http://menu.2ch.net/bbsmenu.html', {})
		D_Net = net.new(false, 'http://menu.2ch.net/bbsmenu.html', {})

	# define ETC
		etc = Struct.new('ETC',
			:sites,
			:list,
			:cfg
		)
		ETC = etc.new([], {}, ETC_TXT)
		#D_ETC = etc.new([], {}, ETC_TXT)

	# end 

	def CFG.init(app_root, app_name, app_version)
		SYS.app_name = app_name
		SYS.app_name_dir = app_root
		SYS.app_version = app_version

		SYS.root = "#{ENV['HOME']}/.#{SYS.app_name_dir}/"
		SYS.siteroot = ''
		SYS.monazilla = "Monazilla/1.00 (#{SYS.app_name}/#{SYS.app_version})"
		Dir.mkdir(SYS.root) unless File.exist?(SYS.root)
	end

	def CFG.load_user_cfg
		cfg = SYS.root + SYS.app_name_dir + CFG_SUFFIX
		eval(IO.readlines(cfg).join) if File.exist?(cfg)

		nwd = SYS.root + NG_WORDS_DAT
		if File.exist?(nwd)
			x = ''
			IO.readlines(nwd).each {|y| x << y.chomp + ',' if y !~ /^#/ }
			x.gsub!(/,\z/, '')
			eval("Net.ng_word = { #{x} }")
		end

		load_etc_txt
	end

	def CFG.load_etc_txt
		sites = []
		list = {}

		cfg = SYS.root + ETC.cfg
		cfg = SYS.siteroot + ETC.cfg unless File.exist?(cfg)

		IO.readlines(cfg).join.split("\n\n").each {|line|
			x = line.split("\n")
			sites << [x[0], x[1]]
			list[x[1]]= x[2]
		}

		ETC.sites = sites
		ETC.list = list
	end
end
