#
#
# $Id: bbsthread.rb,v 1.18 2005/12/21 13:43:07 ys Exp $
#
#

class BBSThread
	require 'nkf'

	CACHE = 'cache'
	LAST = 'last'
	PAST = 'past'

	attr_reader :bookmark, :abone

	def initialize(board, dat)
		if CFG::ETC.list.include?(board)
			id = CFG::ETC.list.fetch(board)  #=> 'dayomon'
			@server, dir = String2ch.parse_uri(board)
			@board ||= dir
			@bookmark ||= Bookmark.new(id)
			@abone ||= Abone.new(id)
			@brd_dir ||= CFG::SYS.root + BBSBoard::EXTRA + id
		else
			@server ||= BBSMenu::Servers[board]
			@board ||= board
			@bookmark ||= Bookmark.new(board)
			@abone ||= Abone.new(board)
			@brd_dir ||= CFG::SYS.root + @board
		end
		@dat ||= dat

		[@bookmark, @abone].each {|sp_handles|
			def sp_handles.set_dat(dat) ; @dat = dat ; end
			def sp_handles.is_included? ; update ; self.include?(@dat) ; end

			def sp_handles.toggle
				case self.is_included?
				when true then delete(@dat)
				when false then add(@dat)
				end
			end

			sp_handles.set_dat(@dat)
		}

		Dir.mkdir("#{@brd_dir}") unless File.exist?("#{@brd_dir}")
		Dir.mkdir("#{@brd_dir}/#{CACHE}/") unless File.exist?("#{@brd_dir}/#{CACHE}/")
		unless File.exist?("#{@brd_dir}/#{CACHE}/#{@dat}")  # ݸΥݽ
			File.unlink(to+".#{LAST}") if File.exist?("#{@brd_dir}/#{CACHE}/#{@dat}.#{LAST}")
			File.unlink(to+".#{CACHE}") if File.exist?("#{@brd_dir}/#{CACHE}/#{@dat}.#{CACHE}")
		end
	end

	def get ; read ; end

	def read
		# not yet. 줷ۤ
		@title = String2ch.get_title("#{@brd_dir}/#{CACHE}/#{@dat}")
		if @title == ''
			@title = String2ch.get_title_more("#{@brd_dir}/#{BBSBoard::S}", @dat)
		end
		str = IO.readlines("#{@brd_dir}/#{CACHE}/#{@dat}.#{CACHE}").join
		return([str, @title])
	end
	private :read

	def get__N(num, fn)
		a = IO.readlines(fn)
		return('No Match.') if num - 1 > a.size
		fw = String2ch.dat2str(a[num - 1], num - 1, false)
		fw = "#{String2ch.get_title(fn)}\n\n#{fw}" if num == 1
		x = fw.gsub(/\n-----\n\z/, '').gsub(/<\/b>/, '').gsub(/<b>/, '')
		return('No Match.') if x == ''
		return(x)
	end

	def get_cache__N(num_str, fn)
		str = ''
		get = false
		case num_str
		when /(.*)-$/
			num = $1.to_i+1
			IO.readlines(fn).each {|x|
				get = true if x =~ /^#{num}:.*/
				str << x if get
			}
		end
		return(str)
	end

	def refresh
		rm_cache(true)

		to = "#{@brd_dir}/#{CACHE}/#{@dat}"
		fh = open("#{to}.#{CACHE}", 'w')
		fh.write String2ch.dat2str(IO.readlines(to).join, 0)
		fh.close
	end

	def rm_cache(only_cache = false)
		to = "#{@brd_dir}/#{CACHE}/#{@dat}"
		if File.exist?(to)
			File.unlink(to) unless only_cache
			File.unlink(to+".#{LAST}") if File.exist?(to+".#{LAST}") unless only_cache
			File.unlink(to+".#{CACHE}") if File.exist?(to+".#{CACHE}")
		end
	end
	private :rm_cache

end


class LiveBBSThread < BBSThread
	def get(reget = false)  # not yet. Net2ch 礹Τηʤ
		# return(super())  # FIXME!!! 줤¤ off-line mode Ĥ줽
		rm_cache if reget

		to = "#{@brd_dir}/#{CACHE}/#{@dat}"
		range = false
		range = "bytes=#{File.stat(to).size - 1}-" if File.exist?(to)
		cache = to+".#{CACHE}"

		result, response = Net2ch.get("http://#{@server}/#{@board}/dat/#{@dat}",
			"#{to}.#{LAST}", range, false)
		return([false, 'Download failed.']) if result == false
		case response.code
		when '206'  # Partical Content
			if response.body[0] == 10
				n = IO.readlines(to).size
				tmp  = response.body[1, response.body.size-1]

				fh = open(to, 'a+')
				fh.write tmp if tmp
				fh.close

				fh = open(cache, 'a+')
				tmp = String2ch.dat2str(tmp, n)
				fh.write tmp if tmp
				fh.close
			end
		when '200'  # OK
			fh = open(to, 'w')
			fh.write response.body
			fh.close

			fh = open(cache, 'w')
			tmp = String2ch.dat2str(response.body, 0)
			fh.write tmp if tmp
			fh.close
		end
		if response.code != '304'
			Net2ch::CacheInfo.write(response.header['Last-Modified'], "#{to}.#{LAST}")
		end

		return(super())
	end

	def get__1(board, dat)
		return(false) unless File.exist?("#{CFG::SYS.root}#{board}/#{CACHE}/#{dat}")
		get__N(1, board, dat)
	end

	def get__N(num, board = @board, dat = @dat)
		if board == @board
			super(num, "#{@brd_dir}/#{CACHE}/#{dat}")
		else
			super(num, "#{CFG::SYS.root}#{board}/#{CACHE}/#{dat}")
		end
	end

	def get_cache__N(num_str, board = @board, dat = @dat)
		super(num_str, "#{CFG::SYS.root}#{board}/#{CACHE}/#{dat}.#{CACHE}")
	end
end


class PastBBSThread < BBSThread
	def initialize(board, dat)
		@bookmark = Bookmark.new(board, PAST)
		@abone = Abone.new(board, PAST)
		@brd_dir = "#{CFG::SYS.root}#{board}/#{PAST}"

		super
	end

	def get__1(board, dat)
		return(false) unless File.exist?("#{CFG::SYS.root}#{board}/#{PAST}/#{CACHE}/#{dat}")
		get__N(1, board, dat)
	end

	def get__N(num, board = @board, dat = @dat)
		super(num, "#{CFG::SYS.root}#{board}/#{PAST}/#{CACHE}/#{dat}")
	end

	def get_cache__N(num_str, board = @board, dat = @dat)
		super(num_str, "#{CFG::SYS.root}#{board}/#{PAST}/#{CACHE}/#{dat}.#{CACHE}")
	end
end
