#
#
# $Id: gtkboard.rb,v 1.28 2005/12/28 14:51:41 ys Exp $
#
#

class SubjectFrame < Gtk::ScrolledWindow
	require 'uconv'

	attr_reader :board, :past, :past_mode

	def initialize(board = false, etc = false)
		@board = board
		@board = 'unix' if @board == false

		@thread_hash = {}  # åɤξ¤ΤǻĤΤɤ
		@bbs_board = LiveBBSBoard.new(@board, false, etc)
		@vadj = Gtk::Adjustment.new(0, 0, 0, 0, 0, 0)

		@past = board
		@pop = false
		@freeze = false  # not yet. 

		@clistin = Gtk::ListStore.new(String, String, String, String, String, String, String, Gdk::Color)
		@clist = Gtk::TreeView.new(@clistin)
		['', 'S', 'C', '', 'F', 'C', ' subject '].each_with_index {|title, i|
			r = Gtk::CellRendererText.new
			if i == 0
				column = Gtk::TreeViewColumn.new(title, r, :text => i, :background_gdk => 7)
			else
				column = Gtk::TreeViewColumn.new(title, r, :text => i)
			end
			column.set_sort_column_id(i)
			@clist.append_column(column)
		}
		@clist.add_vikey_events(@vadj)
		@clist.headers_visible = false
		#@clist.rules_hint = true
		#@clist.set_fixed_height_mode(true)

		right_menu_init

		@clist.signal_connect('key_press_event') {|w, e|
			case e.keyval
			when Gdk::Keyval::GDK_a
				@bbs_board.bookmark.toggle(@thread_hash[@clist.selection.selected.get_value(0)])
			when Gdk::Keyval::GDK_d
				@bbs_board.abone.toggle(@thread_hash[@clist.selection.selected.get_value(0)])
				#FIXME!! delete abone thead.
			when Gdk::Keyval::GDK_D
				if mode == 'past'
					r = 0
					@clist.each_selection {|row| r = row }
					@bbs_board.trash(@thread_hash[@clist.get_text(r, 0)])
					@clist.remove_row(r)
					@clist.select_row(r, 0)
				end
			when Gdk::Keyval::GDK_equal then check('cache_plus')
			when Gdk::Keyval::GDK_s then check('update')
			when Gdk::Keyval::GDK_b then check('bookmark')
			end
		}

		f, array = @bbs_board.get
		get(array) if f

		super(nil, @vadj)
		set_size_request(50, 50)
		self.set_policy(Gtk::POLICY_NEVER, Gtk::POLICY_AUTOMATIC)
		self.add @clist
	end

	def switch(board, etc = false)
		@past = @board
		@past_mode = 'live'
		@board = board
		@bbs_board = LiveBBSBoard.new(@board.dup, @bbs_board.flags, etc)
	end

	def refresh
		@bbs_board.flags.members.each {|x| @bbs_board.flags[x] = false }
		@bbs_board.flags.abone = true
		update(false)
	end

	def toggle  # live  past  toggle
		case mode
		when 'live' then @bbs_board = PastBBSBoard.new(@board, @bbs_board.flags)
		when 'past' then @bbs_board = LiveBBSBoard.new(@board, @bbs_board.flags)
		end
		f, array = @bbs_board.get
		if f
			get(array)
		else
			return(false)
		end
	end

	def mode
		case @bbs_board.class.to_s
		when 'LiveBBSBoard' then return('live')
		when 'PastBBSBoard' then return('past')
		end
	end

	def get(subjects_array)
		return(false) if @freeze
		@clist.freeze_notify
		@clistin.clear
		@thread_hash.clear
		n = 0
		subjects_array.each {|th|
			n += 1
			row = @clistin.append
			s = Uconv.euctou8(th[6].chomp)

			color = nil
			if @bbs_board.abone.include?(th[3])
				color = CFG::GDK_Color.abone_bg
			elsif @bbs_board.bookmark.include?(th[3])
				color = CFG::GDK_Color.bookmark_bg
			end

			[n.to_s, th[0], th[1], th[2], th[4], th[5], s, color].each_with_index{|v, i|
				row[i]= v
			}
			@thread_hash[n.to_s]= th[3]
		}
		@clist.thaw_notify
	end

	def update(get = true)
		f, array = @bbs_board.get(get)
		if f
			get(array)
		else
			return(false)
		end
	end

	def find(word)
		get(@bbs_board.get_find(word))
	end

	def rollback
		@bbs_board.rollback
	end

	def check(flag)
		if @bbs_board.flags[flag]
			@bbs_board.flags[flag] = false
		else
			@bbs_board.flags[flag] = true
		end
		update(false)
	end

	def cached(row)
		@clistin.set_value(row, 2, 'C')
		@clistin.set_value(row, 3, '=')
		@clistin.set_value(row, 5, row.get_value(4))

		#=> subject.txtʤĤ塢downloadĤΥ褦Ȥ
		# not yet. ޤ˷ݤʤΤǡʤȤ졣
		begin
			begin
				@bbs_board.cached(@thread_hash[row.get_value(0)], @board)
			rescue
				@bbs_board.cached(@thread_hash[row.get_value(0)], @past)
			end
		rescue
			# Ǥʤ̵
		end
	end

	def child
		@clist
	end

	def hash
		@thread_hash
	end

	def filter
		@bbs_board.flags
	end

	def bookmark
		@bbs_board.bookmark
	end

	def abone
		@bbs_board.abone
	end

	def freeze
		@freeze = true
	end

	def thaw
		@freeze = false
	end

	def pop?
		if @pop
			@pop = false
			return(true)
		else
			return(false)
		end
	end

	def right_menu_init
		@clist.signal_connect('button_release_event') {|w, e|
			if e.button == 3
				@pop = true
				menu = GtkExt::RightMenu.new(@clist.selection.selected.get_value(6))
				@bbs_board.bookmark.update
				if @bbs_board.bookmark.include?(@thread_hash[@clist.selection.selected.get_value(0)])
					menu.bookmark.child.set_text(CFG::NLS.srm_delete_bkmk)
				else
					menu.bookmark.child.set_text(CFG::NLS.srm_add_bkmk)
				end
				if @bbs_board.abone.include?(@thread_hash[@clist.selection.selected.get_value(0)])
					menu.abone.child.set_text(CFG::NLS.srm_unset_abone)
				else
					menu.abone.child.set_text(CFG::NLS.srm_set_abone)
				end
				menu.title.signal_connect('activate') {
					menu.destroy
				}
				menu.browser.signal_connect('activate') {
					#Net2ch.exec_http_ext(
					#FIXME!! p @thread_hash[@clist.selection.selected.get_value(0)]  # past ʬ⡣
					menu.destroy
				}
				menu.bookmark.signal_connect('activate') {
					@bbs_board.bookmark.toggle(@thread_hash[@clist.selection.selected.get_value(0)])
					menu.destroy
				}
				menu.abone.signal_connect('activate') {
					@bbs_board.abone.toggle(@thread_hash[@clist.selection.selected.get_value(0)])
					#FIXME!! @clist.remove_row(r)
					menu.destroy
				}
				menu.popup(nil, nil, e.button, e.time)
			end
		}
	end
	private :right_menu_init

end
