#
#
# $Id: gtkcfg.rb,v 1.23 2005/12/29 14:34:47 ys Exp $
#
#

class CFG
	def CFG.gui_init
		CFG::Color.members.each {|x|
			CFG::GDK_Color[x] = Gdk::Color.new(CFG::Color[x][0], CFG::Color[x][1], CFG::Color[x][2])
		}
	end
end

class String
	def String.utf8cnvrt(string)
		GLib.convert(string, 'utf-8', 'euc-jp')
	end
end

class ConfigWindow < Gtk::Window

	def initialize
		note = Gtk::Notebook.new.set_scrollable(true)

		note.append_page(generic_cfg, Gtk::Label.new(String.utf8cnvrt('')))
		note.append_page(thread_cfg, Gtk::Label.new(String.utf8cnvrt('å')))
		note.append_page(misc_cfg, Gtk::Label.new(String.utf8cnvrt('¿ɽ')))

		super()
		set_title('Configuration')
		signal_connect('delete_event') { @cancel.clicked }

		spacer = Gtk::VBox.new(false, 15)
		spacer.border_width = 15 
		spacer.pack_start note
		spacer.pack_start setting_buttons
		add spacer
	end

	def setting_buttons
		@ok = Gtk::Button.new('OK')
		@ok.signal_connect('clicked') { write ; @cancel.clicked }

		@cancel = Gtk::Button.new(String.utf8cnvrt('󥻥'))
		@cancel.signal_connect('clicked') { self.destroy }

		box = Gtk::HBox.new(true, 10)
		[Gtk::Label.new(''), Gtk::Label.new(''), @ok, @cancel].each {|x| box.pack_start x }
		box
	end
	private :setting_buttons

	def generic_cfg
		@bbsmenu_check = Gtk::CheckButton.new(String.utf8cnvrt('ưİ򹹿'))
		@bbsmenu_check.active = CFG::Net.bbsmenu_check

		@board_start_open = Gtk::CheckButton.new(String.utf8cnvrt('ưİ򳫤'))
		@board_start_open.active = CFG::UIF.board_start_open

		@bbsmenu_url = Gtk::Entry.new.set_editable(true).set_text(CFG::Net.bbsmenu_url)
		@http_cmd = Gtk::Entry.new.set_editable(true).set_text(CFG::EXT.http_cmd)
		
		box = Gtk::VBox.new(false, 10)
		box.border_width = 20
		[@bbsmenu_check, @board_start_open, 
			hbox_pack(@bbsmenu_url, String.utf8cnvrt('İμ')),
			hbox_pack(@http_cmd, String.utf8cnvrt(' Web ֥饦')),
			Gtk::Label.new(''), subject_cfg,
			Gtk::Label.new(''), proxy_cfg
			].each {|x| box.pack_start x, false }
		box
	end

	def subject_cfg
		@bbg_bar = style_button(CFG::Color.bookmark_bg, String.utf8cnvrt('֥åޡ'))
		@bbg_bar.signal_connect('clicked') { init_color_selection(String.utf8cnvrt('֥åޡطʿ'), @bbg_bar) }
		@abg_bar = style_button(CFG::Color.abone_bg, String.utf8cnvrt('ܡ'))
		@abg_bar.signal_connect('clicked') { init_color_selection(String.utf8cnvrt('ܡطʿ'), @abg_bar) }

		box = Gtk::VBox.new(false, 5)
		box.border_width = 10
		[@bbg_bar, @abg_bar].each {|x| box.pack_start x, false }

		f = Gtk::Frame.new(String.utf8cnvrt('åɰطʿ')).add box
	end

	def thread_cfg
		@name = Gtk::Entry.new.set_editable(true).set_text(CFG::Identity.name)
		@mailto = Gtk::Entry.new.set_editable(true).set_text(CFG::Identity.mailto)

		i_entries = Gtk::VBox.new(false, 5)
		[@name, @mailto].each {|x| i_entries.pack_start x }

		i_labels = Gtk::VBox.new(false, 5)
		['ƻ Name ', 'ƻ Mail '].each {|x| i_labels.pack_start Gtk::Label.new(String.utf8cnvrt(x)) }

		@thread_auto_next = Gtk::CheckButton.new(String.utf8cnvrt('ǲǥڡǡΥذư'))
		@thread_auto_next.active = CFG::UIF.thread_auto_next

		@postbox_auto_scroll = Gtk::CheckButton.new(String.utf8cnvrt('Ƹ塢ǲإ'))
		@postbox_auto_scroll.active = CFG::UIF.postbox_auto_scroll

		e_box = Gtk::HBox.new(false, 5)
		e_box.border_width = 3
		e_box.pack_start i_labels, false
		e_box.pack_start i_entries
		i_box = Gtk::VBox.new(false, 5)
		i_box.border_width = 5
		i_box.pack_start e_box, false
		i_box.pack_start @thread_auto_next, false
		i_box.pack_start @postbox_auto_scroll, false

		@thread_base_fg = style_button(CFG::Color.thread_base_fg)
		@thread_base_fg.signal_connect('clicked') { init_color_selection(String.utf8cnvrt('ܿ'), @thread_base_fg) }
		@thread_quote_fg = style_button(CFG::Color.thread_quote_fg)
		@thread_quote_fg.signal_connect('clicked') { init_color_selection(String.utf8cnvrt('ʸ'), @thread_quote_fg) }
		@thread_header_fg = style_button(CFG::Color.thread_header_fg)
		@thread_header_fg.signal_connect('clicked') { init_color_selection(String.utf8cnvrt('إå'), @thread_header_fg) }
		@thread_followup_fg = style_button(CFG::Color.thread_followup_fg)
		@thread_followup_fg.signal_connect('clicked') { init_color_selection('>>n', @thread_followup_fg) }
		@thread_uri_fg = style_button(CFG::Color.thread_uri_fg)
		@thread_uri_fg.signal_connect('clicked') { init_color_selection('uri', @thread_uri_fg) }

		c_buttons = Gtk::VBox.new(false, 5)
		[ @thread_base_fg, @thread_quote_fg, @thread_header_fg, @thread_followup_fg, @thread_uri_fg].each {|x|
			c_buttons.pack_start x
		}

		c_labels = Gtk::VBox.new(false, 5)
		['ܿ', 'ʸ', 'إå', '>>n', ' URI '].each {|x|
			c_labels.pack_start Gtk::Label.new(String.utf8cnvrt(x))
		}

		c_box = Gtk::HBox.new(false, 5)
		c_box.border_width = 10
		c_box.pack_start c_labels, false
		c_box.pack_start c_buttons

		c_f = Gtk::Frame.new(String.utf8cnvrt('ʸʸ')).add c_box

		adj = Gtk::Adjustment.new(CFG::UIF.postbox_height, 1, 1000, 1, 1, 0)
		@postbox_height = Gtk::SpinButton.new(adj, 0, 0)

		pb_box = Gtk::HBox.new(false, 10)
		pb_box.border_width = 10
		pb_box.pack_start hbox_pack(@postbox_height, String.utf8cnvrt('⤵')), false
		pb_frame = Gtk::Frame.new(String.utf8cnvrt('ƥܥå')).add pb_box

		box = Gtk::VBox.new(false, 15)
		box.border_width = 20
		[i_box, c_f, pb_frame].each {|x| box.pack_start x, false }
		box
	end

	def proxy_cfg
		CFG::Proxy.get_addr ||= ''
		CFG::Proxy.get_port ||= ''
		CFG::Proxy.post_addr ||= ''
		CFG::Proxy.post_port ||= ''

		@get_addr = Gtk::Entry.new.set_editable(true).set_text(CFG::Proxy.get_addr)
		@get_port = Gtk::Entry.new.set_editable(true).set_text(CFG::Proxy.get_port).set_width_request(50)
		get_box = Gtk::HBox.new(false, 5)
		get_box.pack_start Gtk::Label.new(String.utf8cnvrt('')), false
		get_box.pack_start @get_addr
		get_box.pack_start @get_port, false

		@post_addr = Gtk::Entry.new.set_editable(true).set_text(CFG::Proxy.post_addr)
		@post_port = Gtk::Entry.new.set_editable(true).set_text(CFG::Proxy.post_port).set_width_request(50)
		post_box = Gtk::HBox.new(false, 5)
		post_box.pack_start Gtk::Label.new(String.utf8cnvrt('')), false
		post_box.pack_start @post_addr
		post_box.pack_start @post_port, false

		box = Gtk::VBox.new(false, 5)
		box.border_width = 10
		[get_box, post_box].each {|x| box.pack_start x }

		f = Gtk::Frame.new(String.utf8cnvrt('ץ')).add box
	end

	def misc_cfg

		@bp_hash = {String.utf8cnvrt('') => true, String.utf8cnvrt('') => false}  # not yet. 
		@board_position_left = Gtk::RadioButton.new(String.utf8cnvrt(''))
		@board_position_right = Gtk::RadioButton.new(@board_position_left, String.utf8cnvrt(''))

		bp_box = Gtk::HBox.new(false, 5)
		bp_box.pack_start Gtk::Label.new(String.utf8cnvrt('')), false
		[@board_position_left, @board_position_right].each {|x| bp_box.pack_start x, false }
		@board_position_right.active = true unless CFG::UIF.board_position

		adj = Gtk::Adjustment.new(CFG::UIF.boardselect_width, 1, 1000, 1, 1, 0)
		@boardselect_width = Gtk::SpinButton.new(adj, 0, 0)

		bs_box = Gtk::HBox.new(false, 10)
		bs_box.pack_start hbox_pack(@boardselect_width, String.utf8cnvrt('')), false

		boardselect_box = Gtk::HBox.new(false, 20)
		boardselect_box.border_width = 10 
		[bp_box, bs_box].each {|x| boardselect_box.pack_start x, false }
		bs_frame = Gtk::Frame.new(String.utf8cnvrt('İ')).add boardselect_box


		@bm_hash = {String.utf8cnvrt('') => true, String.utf8cnvrt('') => false}  # not yet. 
		@bm_button_position_top = Gtk::RadioButton.new(String.utf8cnvrt(''))
		@bm_button_position_bottom = Gtk::RadioButton.new(@bm_button_position_top, String.utf8cnvrt(''))

		bmp_box = Gtk::HBox.new(false, 5)
		bmp_box.pack_start Gtk::Label.new(String.utf8cnvrt('')), false
		[@bm_button_position_top, @bm_button_position_bottom].each {|x| bmp_box.pack_start x, false }
		@bm_button_position_bottom.active = true unless CFG::UIF.bm_button_position

		adj = Gtk::Adjustment.new(CFG::UIF.favorite_buttons, 0, 100, 1, 1, 0)
		@favorite_buttons = Gtk::SpinButton.new(adj, 0, 0)

		bm_box = Gtk::VBox.new(false, 10)
		[[@favorite_buttons, String.utf8cnvrt(' (0̵)')]].each {|x, y| bm_box.pack_start hbox_pack(x, y), false }

		bm_button_box = Gtk::HBox.new(false, 20)
		bm_button_box.border_width = 10
		[bmp_box, bm_box].each {|x| bm_button_box.pack_start x, false}
		bmp_frame = Gtk::Frame.new(String.utf8cnvrt('ĥܥ')).add bm_button_box


		adj = Gtk::Adjustment.new(CFG::UIF.tab_width, 1, 20, 1, 1, 0)
		@tab_width = Gtk::SpinButton.new(adj, 0, 0)

		@tb_hash = {String.utf8cnvrt('ɽ') => 0, String.utf8cnvrt('"Ĥ"') => 1, String.utf8cnvrt('"Ĥ""ư"') => 2}  # not yet. 
		@tabbutton_type_0 = Gtk::RadioButton.new(String.utf8cnvrt('ɽ'))
		@tabbutton_type_1 = Gtk::RadioButton.new(@tabbutton_type_0, String.utf8cnvrt('"Ĥ"'))
		@tabbutton_type_2 = Gtk::RadioButton.new(@tabbutton_type_0, String.utf8cnvrt('"Ĥ""ư"'))

		tt_radio_box = Gtk::HBox.new(false, 5)
		[@tabbutton_type_0, @tabbutton_type_1 ,@tabbutton_type_2].each {|x| tt_radio_box.pack_start x, false }
		tt_box = Gtk::HBox.new(false, 5)
		[Gtk::Label.new(String.utf8cnvrt('ܥΥ :')), Gtk::Label.new('')].each {|x| tt_box.pack_start x, false }
		case CFG::UIF.tabbutton_type
		when 0 then @tabbutton_type_0.active = true
		when 1 then @tabbutton_type_1.active = true
		when 2 then @tabbutton_type_2.active = true
		end

		tab_box = Gtk::VBox.new(false, 10)
		tab_box.border_width = 10
		[hbox_pack(@tab_width, String.utf8cnvrt('٥ʸ'), false), tt_box, tt_radio_box].each {|x|
			tab_box.pack_start x, false
		}
		tab_frame = Gtk::Frame.new(String.utf8cnvrt('֥٥')).add tab_box


		@tablock_check = Gtk::CheckButton.new(String.utf8cnvrt('åɤ򳫤塢Υ֤ذưʤ'))
		@tablock_check.active = CFG::UIF.tab_lock

		adj = Gtk::Adjustment.new(CFG::UIF.searched_max, 1, 100, 1, 1, 0)
		@searched_max = Gtk::SpinButton.new(adj, 0, 0)

		etc_box = Gtk::VBox.new(false, 10)
		etc_box.border_width = 10
		etc_box.pack_start @tablock_check, false
		etc_box.pack_start hbox_pack(@searched_max, String.utf8cnvrt('Url Сݻ븡ʸ'), false), false
		etc_frame = Gtk::Frame.new(String.utf8cnvrt('¾')).add etc_box

		box = Gtk::VBox.new(false, 15)
		box.border_width = 20
		[bs_frame, bmp_frame, tab_frame, etc_frame].each {|x| box.pack_start x, false }
		box
	end
	private :generic_cfg, :subject_cfg, :thread_cfg, :proxy_cfg, :misc_cfg

	def hbox_pack(widget, label, widget_expand = true)
		box = Gtk::HBox.new(false, 5)
		if label.class.to_s == 'String'
			box.pack_start Gtk::Label.new(label), false
		else
			box.pack_start label, false
		end
		box.pack_start widget, widget_expand
	end
	private :hbox_pack

	def style_button(color_array, string = false)
		style = Gtk::Style.new
		style.set_bg(Gtk::STATE_NORMAL, color_array[0], color_array[1], color_array[2])
		if string
			Gtk::Button.new(string).set_style(style)
		else
			Gtk::Button.new('').set_style(style)
		end
	end
	private :style_button

	def init_color_selection(title, target_widget)
		csd = Gtk::ColorSelectionDialog.new(title)
		csd.set_modal(true)
		cs = csd.colorsel
		cs.set_current_color(target_widget.style.bg(Gtk::STATE_NORMAL))

		csd.ok_button.signal_connect('clicked') {
			a = cs.current_color.to_a
			style = Gtk::Style.new
			style.set_bg(Gtk::STATE_NORMAL, a[0], a[1], a[2])
			target_widget.set_style(style)
			csd.destroy
		}
		csd.cancel_button.signal_connect('clicked') { csd.destroy }
		csd.show_all
		cs.set_has_opacity_control(false)
		csd.help_button.hide
	end
	private :init_color_selection

	def get_setting
		cfg = {}

		# generic
		cfg['bbsmenu_check']= @bbsmenu_check.active?
		cfg['board_start_open']= @board_start_open.active?
		cfg['bbsmenu_url']= @bbsmenu_url.text
		cfg['http_cmd']= @http_cmd.text

		# subject
		cfg['bookmark_bg']= @bbg_bar.style.bg(Gtk::STATE_NORMAL).to_a
		cfg['abone_bg']= @abg_bar.style.bg(Gtk::STATE_NORMAL).to_a

		# thread
		cfg['name']= @name.text
		cfg['mailto']= @mailto.text
		cfg['thread_auto_next']= @thread_auto_next.active?
		cfg['thread_base_fg']= @thread_base_fg.style.bg(Gtk::STATE_NORMAL).to_a
		cfg['thread_quote_fg']= @thread_quote_fg.style.bg(Gtk::STATE_NORMAL).to_a
		cfg['thread_header_fg']= @thread_header_fg.style.bg(Gtk::STATE_NORMAL).to_a
		cfg['thread_followup_fg']= @thread_followup_fg.style.bg(Gtk::STATE_NORMAL).to_a
		cfg['thread_uri_fg']= @thread_uri_fg.style.bg(Gtk::STATE_NORMAL).to_a
		cfg['postbox_auto_scroll']= @postbox_auto_scroll.active?
		cfg['postbox_height']= @postbox_height.value_as_int

		# proxy
		['get_addr', 'get_port', 'post_addr', 'post_port'].each {|x| cfg[x]= nil }
		CFG::Proxy.get_addr = nil  ; CFG::Proxy.get_port = nil
		CFG::Proxy.post_addr = nil ; CFG::Proxy.post_port = nil
		cfg['get_addr']= @get_addr.text if @get_addr.text != ''
		cfg['get_port']= @get_port.text if @get_port.text != ''
		cfg['post_addr']= @post_addr.text if @post_addr.text != ''
		cfg['post_port']= @post_port.text if @post_port.text != ''

		# misc
		@board_position_left.group.each {|x| cfg['board_position']= @bp_hash[x.child.text] if x.active? }
		@bm_button_position_top.group.each {|x| cfg['bm_button_position']= @bm_hash[x.child.text] if x.active? }
		cfg['tab_width']= @tab_width.value_as_int
		@tabbutton_type_0.group.each {|x| cfg['tabbutton_type']= @tb_hash[x.child.text] if x.active? }
		cfg['boardselect_width']= @boardselect_width.value_as_int
		cfg['searched_max']= @searched_max.value_as_int
		cfg['favorite_buttons']= @favorite_buttons.value_as_int
		cfg['tab_lock']= @tablock_check.active?

		return(cfg)
	end
	private :get_setting

	def to_string(value)
		case value.class.to_s
		when 'String'
			return("'#{value}'")
		when 'Array'
			return('[ ' + value.join(', ') + ' ]')
		when 'Hash'
			x = []
			value.each_pair {|key, value| x << "\t/#{regex2string(key)}/ => '#{value}'"}
			return("{\n" + x.join(",\n") + "\n\t}")
		when 'NilClass'
			return('nil')
		else
			return(value.to_s)
		end
	end
	private :to_string

	def regex2string(str)  # not yet.
		str.gsub!('/', '\/')
		str.gsub!('.', '\.')
		str.gsub!('-', '\-')
		str.gsub!('(', '\(')
		str.gsub!(')', '\)')
		str.gsub!(')', '\)')
		str.gsub!('[', '\[')
		str.gsub!(']', '\]')
		return(str)
	end
	private :regex2string

	def write
		str = ''
		a = []
		CFG::Identity.myfavorites.each {|x| a << to_string(x) }
		str << 'Identity.myfavorites = [' + a.join(', ') + ']' + "\n"
		# str << "Net.ng_word = #{to_string(CFG::Net.ng_word)}\n"  # not yet.

		# UIF, EXT, Proxy, Color, Identity, Net
		cfg = get_setting
		['UIF', 'EXT', 'Proxy', 'Color', 'Identity', 'Net'].each {|struct|
			eval("CFG::#{struct}").members.each {|x|
				if cfg.member?(x) and if cfg[x] != eval("CFG::D_#{struct}.#{x}")
					str << struct + '.' + x + ' = ' + to_string(cfg[x]) + "\n" if cfg.member?(x)
				end ; end
			}
		}

		fh = open(CFG::SYS.root + CFG::SYS.app_name_dir + '.cfg', 'w')
		fh.write str
		fh.close

		CFG.load_user_cfg
		CFG.gui_init
	end
	private :write
end
