#
#
# $Id: gtkpost.rb,v 1.13 2005/12/20 14:11:33 ys Exp $
#
#

class BBSPostBox < Gtk::VBox
	attr_reader :text, :cancel_button, :quote_button, :posting
	POST_POST = '.post'
	PRE_QUOTE_NUM = '>>'
	PRE_QUOTE = '> '
	RE = ' Re: '

	def initialize(board, dat, title)
		@board = board
		@dat = dat
		@title = title
		@getThread = Thread.fork { Thread.exit }
		@update = false
		@posting = false

		super()

		@cancel_button = Gtk::Button.new.add Pix.get('cancel')
		@quote_button = Gtk::Button.new.add Pix.get('quote')
		post_button = Gtk::Button.new.add Pix.get('followup')
			post_button.signal_connect('clicked') {
				@status.set_text(CFG::NLS.pbx_posting)
				@getThread = Thread.fork {
					n = Uconv.u8toeuc(@nameEntry.entry.text)
					m = Uconv.u8toeuc(@mailEntry.entry.text)
					@posting = true
					wrote, body = BBSPost.post(@board, @dat, n,  m, Uconv.u8toeuc(@text.buffer.text))
					@posting = false
					if wrote
						#BBSPost.write_info(n, m, "#{CFG::SYS.root}#{@board}/cache/#{@dat}#{POST_POST}")
						@update = true
						@cancel_button.clicked
					else
						@status.set_text(Uconv.euctou8(body))
					end
				}
			}
		GtkExt.set_tooltip(@cancel_button, CFG::NLS.ttp_close)
		GtkExt.set_tooltip(@quote_button, CFG::NLS.ttp_quote)
		GtkExt.set_tooltip(post_button, CFG::NLS.ttp_post)

		aa_button, aa_menu_root, aa_menu = GtkExt::Menus.init(CFG::NLS.ttp_aa, CFG::NLS.pbx_aa)
		BBSPost::AA.get_list.each {|aa|
			label = Gtk::MenuItem.new(Uconv.euctou8(aa.chomp))
			aa_menu.append label
			label.signal_connect('activate') { @text.buffer.insert_at_cursor(Uconv.euctou8(aa.chomp)) }
		}

		filter_button, fi_menu_root, fi_menu = GtkExt::Menus.init(CFG::NLS.ttp_filter,  CFG::NLS.pbx_filter)
		BBSPost::Filter.get_list.each {|fi|
			label = Gtk::MenuItem.new(Uconv.euctou8(fi))
			fi_menu.append label
			label.signal_connect('activate') {
				str = Uconv.u8toeuc(@text.buffer.text)
				@text.buffer.set_text('')
				@text.buffer.insert_at_cursor(Uconv.euctou8(BBSPost::Filter.exec(fi, str)))
			}
		}

		blank = Gtk::Label.new('')
		@titleLabel = Gtk::Label.new('')

		sw = Gtk::ScrolledWindow.new
		sw.set_policy(Gtk::POLICY_NEVER, Gtk::POLICY_AUTOMATIC)
		@text = Gtk::TextView.new
		@buffer = @text.buffer
		@text.editable = true
		@text.signal_connect('key_press_event') {|w, e|
			if e.state == Gdk::Window::ModifierType::CONTROL_MASK
				case e.keyval
				when Gdk::Keyval::GDK_Return
					post_button.clicked
				when Gdk::Keyval::GDK_c
					@cancel_button.clicked
				when Gdk::Keyval::GDK_t
					aa_menu.popup(nil, nil, 1, e.time)
				when Gdk::Keyval::GDK_f
					fi_menu.popup(nil, nil, 1, e.time)
				end
			end
		}
		sw.add @text

		bBox = Gtk::HBox.new
		bBox.pack_start @titleLabel, false
		bBox.pack_start blank, true
		bBox.pack_start post_button, false
		bBox.pack_start @cancel_button, false
		bBox.pack_start @quote_button, false
		bBox.pack_start aa_button, false
		bBox.pack_start filter_button, false

		[post_button, @cancel_button, @quote_button].each {|w|
			w.relief = Gtk::RELIEF_NONE
		}
		
		nameLabel = Gtk::Label.new(' Name ')
		mailLabel = Gtk::Label.new(' Mailto ')
		@nameEntry = Gtk::Combo.new
		@mailEntry = Gtk::Combo.new

		nBox = Gtk::HBox.new
		nBox.pack_start nameLabel, false
		nBox.pack_start @nameEntry
		nBox.pack_start mailLabel, false
		nBox.pack_start @mailEntry

		@status = Gtk::Label.new('')

		self.pack_start bBox, false
		self.pack_start nBox, false
		self.pack_start sw, true
		self.pack_start @status, false
	end

	def post?(p = false)
		@update = false if p
		return(@update)
	end

	def clear
		@text.buffer.set_text('')
		[@nameEntry.entry, @mailEntry.entry, @titleLabel, @status].each {|x| x.set_text('') }
	end

	def clear?
		if @titleLabel.text == ''
			return(true)
		else
			return(false)
		end
	end

	def show_all(str = false, num = false)
		insert_reply(str, num) if str
		name, mailto = BBSPost.read_info("#{CFG::SYS.root}#{@board}/cache/#{@dat}#{POST_POST}")
		@nameEntry.entry.set_text(name[0])
		@nameEntry.set_popdown_strings(name)
		@mailEntry.entry.set_text(mailto[0])
		@mailEntry.set_popdown_strings(mailto)
		@titleLabel.set_text(RE + Uconv.euctou8(@title))
		super()
	end

	def insert_reply(str, num)
		@buffer.insert_at_cursor PRE_QUOTE_NUM + num.to_s.concat("\n")
		str.each {|line| @buffer.insert_at_cursor PRE_QUOTE + line.sub(/^\s/, '')}
		@buffer.insert_at_cursor "\n"
	end
end
