#
#
# $Id: gtkthread.rb,v 1.36 2005/12/31 13:22:23 ys Exp $
#
#

class ThreadFrame < Gtk::VPaned
	require 'nkf'

	attr_reader :post, :vadj_info, :vadj, :close, :prev, :next
	attr_reader :bookmark, :abone, :press

	def initialize(board, dat, url)
		if CFG::ETC.list.include?(board)
			id = BBSBoard::EXTRA + CFG::ETC.list.fetch(board)
			@id = {'board' => id, 'dat' => dat, 'url' => url }
			@bbs_thread ||= LiveBBSThread.new(board, dat)
			@vadj ||= Gtk::Adjustment.new(0, 0, 0, 0, 0, 0)
			@vadj_info ||= GtkExt::AdjInfo.new(id, dat, @vadj)
		else
			@id = {'board' => board, 'dat' => dat, 'url' => url }
			@bbs_thread ||= LiveBBSThread.new(board, dat)
			@vadj ||= Gtk::Adjustment.new(0, 0, 0, 0, 0, 0)
			@vadj_info ||= GtkExt::AdjInfo.new(board, dat, @vadj)
		end

		@bookmark = @bbs_thread.bookmark
		@abone = @bbs_thread.abone

		sw = Gtk::ScrolledWindow.new(nil, @vadj)
		sw.set_policy(Gtk::POLICY_NEVER, Gtk::POLICY_AUTOMATIC)
		@text = Gtk::TextView.new
		@text.left_margin = 15
		@text.right_margin = 10
		@text.wrap_mode = 2
		@text.add_vikey_events(@vadj)
		@text.add_mousescroll_events(@vadj)
		@text.set_cursor_visible(false)
		@buffer = @text.buffer

		@text.signal_connect('key_press_event') {|w, e|
			case e.keyval
			when Gdk::Keyval::GDK_f
				refresh
			end
		}

		# from RBBR Thanx!
		@press = nil
		@text.signal_connect('button_press_event') {|w, e|
			@press = e.event_type
			false
		}

		@text.signal_connect('button_release_event') {|w, e|
			if e.button == 1 and @press == Gdk::Event::BUTTON_PRESS
				win, x, y, modtype = *e.window.pointer
				if x and y
					bx, by = @text.window_to_buffer_coords(Gtk::TextView::WINDOW_TEXT, x, y)
					st = @text.get_iter_at_location(bx, by)
					en = st.dup
					st.backward_to_tag_toggle
					en.forward_to_tag_toggle
					target = Uconv.u8toeuc(@buffer.get_text(st, en))
					target.gsub!(/[>]*/, '').strip!

					case target
					when /^[\d-]+/e
						x = @bbs_thread.get__N(NKF.nkf('-Z', target).to_i)
						if x != ''
							x = Uconv.euctou8(x)
							GtkExt::FollowPop.new(x).popup(nil, nil, e.button, e.time)
						end
					when CFG::Regex.uri_2ch  # FIXME!!!
						b = $3 ; d = $4
						b.sub(/(.+?)\/(\d+)/) { b = $1 ; d = $2 } if b =~ /\//
						x = @bbs_thread.get__1(b, d+'.dat')
						if x
							x = Uconv.euctou8(x)
							GtkExt::FollowPop.new(x).popup(nil, nil, e.button, e.time)
						end
					when CFG::Regex.uri
						Net2ch.exec_http_ext(target)
					end
				end
			end
			@press = nil
			false
		}

		get
		sw.add @text

		super()
		set_size_request(50, 50)
		self.pack1(sw, false, false)
		self
	end

	def get
		th, @id['title'] = @bbs_thread.get
		th = CFG::NLS.moved_dat_hell.sub(/%url/, @id['url']) if th == false
		insert_thread(th)
	end

	def get_fup_num  # not yet. 1-20 ˤбǤ褦˳ĥͽꡣ
		n = ''
		Uconv.u8toeuc(@text.buffer.text).each {|x| n = x if x =~ CFG::Regex.id }
		n.sub!(/:.*/, '').chomp!
	end

	def update
		# no work.
	end

	def dat
		@id['dat']
	end

	def board
		@id['board']
	end

	def title
		@id['title']
	end

	def url
		@id['url']
	end

	def child
		@text
	end

	def adjust(value = false)
		o = @vadj.upper
		while true
			sleep 0.3
			if o == @vadj.upper
				break
			else
				o = @vadj.upper
			end
		end
		value = @vadj_info.get unless value
		@vadj.set_value(value)
		if @vadj.value > @vadj.upper - vadj.page_size
			@vadj.set_value(@vadj.upper - vadj.page_size)
		end
	end
	
	def get_selection(get_num = false)
		selections = @buffer.selection_bounds
		if selections[0] == selections[1]
			return('')
		else
			sel_str = @buffer.get_text(selections[0], selections[1])
			if get_num
				num = ''
				pre_sel = @buffer.get_text(@buffer.start_iter, selections[0])
				pre_sel.split("\n").reverse_each {|line|
					if line =~ CFG::Regex.head_id
						num = $1
						break
					end
				}
				return([sel_str.chomp, num])
			else
				return sel_str.chomp
			end
		end
	end

	def label
		case CFG::UIF.tabbutton_type
		when 0
			label = Gtk::Label.new(Uconv.euctou8("#{String2ch.trunc(@id['title'])}"))  # ܥ󤬤ʤẸ
			label.show_all
			return([label])
		when 1
			label = Gtk::Label.new(Uconv.euctou8("#{String2ch.trunc(@id['title'])} "))
			@close = Gtk::Button.new.add Pix.get('close')
			@close.relief = Gtk::RELIEF_NONE
			box = Gtk::HBox.new
			box.pack_start label
			box.pack_start @close, false
			box.show_all
			return([box, @close])
		else
			label = Gtk::Label.new(Uconv.euctou8("#{String2ch.trunc(@id['title'])} "))
			@close = Gtk::Button.new.add Pix.get('close')
			@next = Gtk::Button.new.add Pix.get('next')
			@prev = Gtk::Button.new.add Pix.get('prev')
			[@close, @next, @prev].each {|w| w.relief = Gtk::RELIEF_NONE }
			box = Gtk::HBox.new
			box.pack_start label
			box.pack_start @prev, false
			box.pack_start @close, false
			box.pack_start @next, false
			box.show_all
			return([box, @close, @prev, @next])
		end
	end

	def find(word)
		return if word == ''
		word = Uconv.euctou8(word) #FIXME!!

		selections = @buffer.selection_bounds
		if selections[0] == selections[1]
			iter = @buffer.get_iter_at_offset(0)
		elsif @buffer.end_iter == @buffer.get_iter_at_mark(@buffer.selection_bound)
			iter = @buffer.get_iter_at_offset(0)
		else
			iter = @buffer.get_iter_at_mark(@buffer.selection_bound)
		end

		match_iters = iter.forward_search(word, Gtk::TextIter::SEARCH_TEXT_ONLY)

		if match_iters
			@buffer.place_cursor(match_iters[0])
			@text.scroll_to_iter(match_iters[0], 0, 0, 0, 0)
			@buffer.move_mark('selection_bound', match_iters[1])
		end
	end

	def insert_thread(stream)
		@text.freeze_notify
		@text.set_editable(true)
		@buffer.create_tag('base', :foreground => 'black')
		@buffer.create_tag('quote', :foreground => 'darkred')
		@buffer.create_tag('delimiter', :foreground => 'gray')
		@buffer.create_tag('header', :foreground => 'darkgreen')
		@buffer.create_tag('followup', :foreground => 'darkblue', :underline => Pango::AttrUnderline::SINGLE)
		@buffer.create_tag('uri', :foreground => 'blue', :underline => Pango::AttrUnderline::SINGLE)
		quote = CFG::GDK_Color.thread_quote_fg
		stream = Uconv.euctou8(stream)
		stream.each {|line|  # from goRua. Thanks.
			line.chomp!
			if line !~ CFG::Regex.quote
				base = 'base'
			else
				base = 'quote'
			end
			while true
				case line
				when /^-----$/  # ǥߥ
					@buffer.insert(@buffer.end_iter, line, 'delimiter')
					break
				when CFG::Regex.id  # إå
					n = $1; i = $2; e = $3
					i.gsub!(/<\/b>/, '')
					i.gsub!(/<b>/, '')
					@buffer.insert(@buffer.end_iter, n, base)
					@buffer.insert(@buffer.end_iter, i, 'header')
					@buffer.insert(@buffer.end_iter,  e, base)
					break
				when CFG::Regex.follow_many  # FollowUpMany
					@buffer.insert(@buffer.end_iter, $1, base)
					@buffer.insert(@buffer.end_iter, $2, 'followup')
					line = $3
				when CFG::Regex.follow  # FollowUp
					@buffer.insert(@buffer.end_iter, $1, base)
					@buffer.insert(@buffer.end_iter, $2, 'followup')
					line = $3
				when CFG::Regex.uri  # URL
					@buffer.insert(@buffer.end_iter, $1, base)
					@buffer.insert(@buffer.end_iter, $2, 'uri')
					line = $3
				else
					@buffer.insert(@buffer.end_iter, line, base)
					break
				end
			end
			@buffer.insert_at_cursor "\n"
		}
		@text.set_editable(false)
		@text.thaw_notify
	end

	def delete_thread
		@text.freeze_notify
		@text.buffer.set_text('')
		@text.thaw_notify
	end
	private :delete_thread

	def refresh
		@bbs_thread.refresh
		delete_thread
		get
	end

	def redraw
		@redraw = true
		self.set_position(1500)
		Thread.fork {
			sleep 3
			@redraw = false
		}
	end

	def redraw?
		@redraw
	end
end


class LiveThreadFrame < ThreadFrame

	attr_reader :post, :mode

	def initialize(board, dat, url)
		super
		@mode = 'live'

		child.signal_connect('key_press_event'){|w, e|
			case e.keyval
			when Gdk::Keyval::GDK_e
				@post.quote_button.clicked
			end
		}

		post_init
		pack2 @post, false, true
	end

	def update(reget = false)
		@bbs_thread.get(reget)
		th = @bbs_thread.get_cache__N(get_fup_num + '-')
		insert_thread(th)
	end

	def reget
		update(true)
	end

	def post_init
		@post = BBSPostBox.new(@id['board'], @id['dat'], @id['title'])

		@post.cancel_button.signal_connect('clicked') {
			unless @post.posting
				post_close
				GtkExt.parent_window(child).set_focus(child)
				if @post.post?
					update
					@vadj.set_value(@vadj.upper - @vadj.page_size) if CFG::UIF.postbox_auto_scroll
					@post.post?(true)
				end
			end
		}

		@post.quote_button.signal_connect('clicked') {
			str , num = get_selection(true)
			@post.insert_reply(str, num)
		}
	end

	def post_open
		selections = @buffer.selection_bounds
		if selections[0] == selections[1]
			@post.show_all
		else
			str, num = get_selection(true)
			@post.show_all(str, num)
		end
		self.set_position(self.window.size[0] - CFG::UIF.postbox_height)
	end

	def redraw
		super
		@post.clear
	end

	alias post_close redraw
end


class PastThreadFrame < ThreadFrame

	PAST = 'past'

	attr_reader :mode

	def initialize(board, dat, url)
		@bbs_thread = PastBBSThread.new(board, dat)
		@vadj = Gtk::Adjustment.new(0, 0, 0, 0, 0, 0)
		@vadj_info = GtkExt::AdjInfo.new(board, dat, @vadj, PAST)

		super
		@mode = 'past'

		self.signal_connect('size_allocate') {
			unless redraw?
				redraw
			end
		}

		add2 Gtk::Label.new('')
	end
end
